ChiliProject - Bug # 133: Add hack for rubygems > 1.5 compatibility

Status: Closed Priority: High
Author: Holger Just Category:

Created: 2011-02-03 Assignee: Holger Just
Updated: 2011-03-02 Due date:

Remote issue URL: http://www.redmine.org/issues/7516

Affected version:

Description: The @version_requirements@ method in rubygems (which is used by Rails 2.3.5) was finaly removed in
rubygems 1.5, after being deprecated for a long time.

There exists a hack for Rails applications which returns compatibility for rubygems 1.5 and removes the
deprecation warning on older rubygem versions, available from the Rails ticket. See

https://rails.lighthouseapp.com/projects/8994/tickets/4026-rubygems-136-warning-in-rails-235

This fix should be included into ChiliProject until we manage to upgrade to a newer Rails version.

Associated revisions

2011-02-22 02:51 pm - Thibaut Deloffre
[#133] Provide workaround for rubygems 1.5 compatibility

Remove the deprecation warnings for version_requirements with rubygems < 1.5

and allow ChiliProject to run with rubygems >= 1.5.

2011-11-25 09:50 pm - Eric Davis
Merge pull request #133 from schmidt/pulls/725/master

[#725] Compatibility check for jQuery availability (master)

History

2011-02-09 11:21 am - Thibaut Deloffre
Hi,

| just send my pull request on github for this fix.

Bye,

Thibaut

2011-02-09 11:42 am - Holger Just

- Status changed from Open to Ready for review

Thibaut Deloffre wrote:

> | just send my pull request on github for this fix.

Please always reference your pull request in the comment so we can actually find it again. Also you really should use feature branches. Please refer to
[[Contribute_Code]] for more information.

Your Pull request is at https://github.com/chiliproject/chiliproject/pull/1.

2011-02-09 12:08 pm - Felix Schafer
That seems like a mouthful, another approach has been suggested in "note 3":http://www.redmine.org/issues/7516#note-3 of the corresponding
redmine bug report.

Thibault: are there any advantages to your method, or disadvantages to the shorter method linked above?

2011-02-09 02:48 pm - Thibaut Deloffre

Holger Just wrote:

> Thibaut Deloffre wrote:

> > | just send my pull request on github for this fix.

>

> Please always reference your pull request in the comment so we can actually find it again. Also you really should use feature branches. Please refer
to [[Contribute_Code]] for more information.

>

> Your Pull request is at https:/github.com/chiliproject/chiliproject/pull/1.

Oh, sorry...

| wont forget for the next time.

2011-02-09 02:53 pm - Thibaut Deloffre

Felix SchArfer wrote:

> That seems like a mouthful, another approach has been suggested in "note 3":http://www.redmine.org/issues/7516#note-3 of the corresponding
redmine bug report.

>

> Thibault: are there any advantages to your method, or disadvantages to the shorter method linked above?

In fact, this method is *exactly* the same that you can find in new rails version.
| just overloaded existing rails methods.

2011-02-15 01:53 pm - Felix Schéfer
OK, I don't care which one gets in as long as it works ;-) My rails-foo is a little low on that one though, so I'll let either Holger or Eric decide which one to

pull in.

2011-02-15 03:19 pm - Thibaut Deloffre

It seems that my code breaks script/console on some rails version.

I'm searching for a new workaround.

2011-02-15 05:18 pm - Thibaut Deloffre

- File 133_add_hack_for_rubygems_gt 1_5_compatibility.patch added

Re

A require was missing.

| attached my patch to this comment.

Bye

2011-02-1505:41 pm-S C
Changing Rails version to 2.3.11 would fix the problem. Just tested by changing the RAILS_GEM_VERSION and it doesn't seem to break.

2011-02-15 05:44 pm - Thibaut Deloffre
- File FINAL_133_add_hack_for_rubygems_gt 1_5_compatibility.patch added
Re

Thx to Simon Courtois who permit the final correction to bypass passenger error.

Bye.

2011-02-18 09:50 am - S C

Did someone of the team tested it ?
It's a pretty important issue | think.
2011-02-20 06:02 pm - Felix Schéfer

Simon COURTOIS wrote:
> Did someone of the team tested it ?

As | said, | don't feel qualified enough :-) Eric, Holger?

2011-02-21 10:47 am - Holger Just
| tested it and it works well. I'm a bit unsure though, if this is really the least invasive method. Gonna dig a bit through the rubygems code later...

2011-02-21 10:54 am - Felix Schafer

Holger Just wrote:

> | tested it and it works well. I'm a bit unsure though, if this is really the least invasive method. Gonna dig a bit through the rubygems code latera€}
From what | gathered it mostly is the code rubygems used in 1.4 for backwards compatibility, so if it works, I'd keep it like that.

2011-02-21 11:50 am - Thibaut Deloffre

Felix SchArfer wrote:

> From what | gathered it mostly is the code rubygems used in 1.4 for backwards compatibility, so if it works, I'd keep it like that.

Yep, it is mostly rubygems code in this patch.

Imho, it'll be easier to maintain with this piece of code.

2011-02-21 11:22 pm - Eric Davis

Holger, it's your call. | don't have rvm set up yet and | don't want to force all of my apps to Rubygems 1.5 yet.

2011-02-21 11:28 pm - Holger Just

- Assignee set to Holger Just

Gonna thoroughly test it tomorrow. But as | said, | think the patch is gonna be fine.

2011-02-22 02:21 pm - Holger Just

- Status changed from Ready for review to Closed

Moved your patch into @boot.rb@ but kept the structure the same. The hack has to be completely removed once we move to a newer Rails version

(see #216)

2011-02-27 10:16 pm - Eric Davis
- Subject changed from Add hack for rubygems > 1.5 compatibiity to Add hack for rubygems > 1.5 compatibility
2011-03-02 12:58 am - Eric Davis

I'm not sure this is fully fixed. Works fine with the full Rails environment but some rake tasks are failing.

<pre>
$ rake gems

(in /home/edavis/dev/chiliproject/core)
- [F] rubytree

rake aborted!

undefined method “version_requirements' for #<Gem::Dependency:0x9ade2fc>

(See full trace by running task with --trace)
$ gem --version
1.5.2

</pre>

Full trace:

<pre>
$ rake gems --trace

(in /home/edavis/dev/chiliproject/core)
** Invoke gems (first_time)

** Invoke gems:base (first_time)

** Execute gems:base

** Invoke environment (first_time)

** Execute environment

** Execute gems

- [F] rubytree

rake aborted!

undefined method “version_requirements' for #<Gem::Dependency:0x8b920c8>
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rails-2.3.5/lib/rails/gem_dependency.rb:86:in "dependencies'
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rails-2.3.5/lib/rails/gem_dependency.rb:83:in "map'
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rails-2.3.5/lib/rails/gem_dependency.rb:83:in "dependencies'

/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rails-2.3.5/lib/tasks/gems.rake:77:in “print_gem_status'

/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rails-2.3.5/lib/tasks/gems.rake:4

/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rails-2.3.5/lib/tasks/gems.rake:3:in “each’

/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rails-2.3.5/lib/tasks/gems.rake:3

/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:636:in
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:636:in
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:631:in
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:631:in °
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:597:in

“call'

execute'

“each’

execute'

invoke_with_call_chain’

/home/edavis/.rvm/rubies/ree-1.8.7-2011.03/lib/ruby/1.8/monitor.rb:242:in “synchronize'

/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:590:in
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:583:in
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:2051:in
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:2029:in
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:2029:in
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:2029:in
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:2068:in
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:2023:in

/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:2001:in °

/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:2068:in

/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/lib/rake.rb:1998:in °
invoke_with_call_chain’
invoke'

‘invoke_task'

“top_level'

“each’

“top_level'
“standard_exception_handling'
“top_level'

run'
“standard_exception_handling'

run'
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/gems/rake-0.8.7/bin/rake:31
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/bin/rake:19:in “load'
/home/edavis/.rvm/gems/ree-1.8.7-2011.03/bin/rake:19

</pre>

2011-03-02 07:49 am - Gregor Schmidt
| think, the safest bet, to fix this problem, still is updating to Rails 2.3.11. Also the newly released RubyGems 1.6 again deprecates loads of methods
that will most probably affect old rails versions.

IMO, updating Rails should be the no. 1 focus for Chili 1.2.

Shouldn't this ticket be reopened or a new ticket be created to discuss your stack trace.

2011-03-02 07:56 am - Gregor Schmidt

OK, | just saw in #196, that you are aiming to include 2.3.11 support in 2.0. Thus, 1.2 should become new 2.0 and old 2.0 should become 3.0.

| think maintaining the hacks to run with current system dependencies like RubyGems or other things, that may not be fixed by bundling them with

releases, as well as porting back Rails security fixes will not be feasible for half a year.

2011-03-02 09:09 am - Thibaut Deloffre
Just to check, the final patch in attachment has been added to chili ?

2011-03-02 09:16 am - Holger Just
Thibaut Deloffre wrote:

> Just to check, the final patch in attachment has been added to chili ?

The gist of it. | moved it from @environment.rb@ to @boot.rb@ and added a few comments but kept the patch itself unchanged.

2011-03-02 09:21 am - Thibaut Deloffre

Holger Just wrote:

> Thibaut Deloffre wrote:

> > Just to check, the final patch in attachment has been added to chili ?
>

> The gist of it. | moved it from @environment.rb@ to @boot.rb@ and added a few comments but kept the patch itself unchanged.

Ok, I'll check.

Files

133_add_hack_for_rubygems_gt_1_5 compatibility.patch 1.6 kB 2011-02-15 Thibaut Deloffre
FINAL_133_add_hack_for_rubygems_gt_1_5 compatibility.patch 1.6 kB 2011-02-15 Thibaut Deloffre
